Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/commands/ImportClipboardText.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/commands/ImportClipboardText.java	(revision 0)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/commands/ImportClipboardText.java	(revision 3441)
@@ -0,0 +1,181 @@
+// Copyright © 2010-2020 ENS de Lyon., University of Franche-Comté
+// Copyright © 2007-2010 ENS de Lyon, CNRS, INRP, University of
+// Lyon 2, University of Franche-Comté, University of Nice
+// Sophia Antipolis, University of Paris 3.
+// 
+// The TXM platform is free software: you can redistribute it
+// and/or modify it under the terms of the GNU General Public
+// License as published by the Free Software Foundation,
+// either version 2 of the License, or (at your option) any
+// later version.
+// 
+// The TXM platform is distributed in the hope that it will be
+// useful, but WITHOUT ANY WARRANTY; without even the implied
+// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+// PURPOSE. See the GNU General Public License for more
+// details.
+// 
+// You should have received a copy of the GNU General
+// Public License along with the TXM platform. If not, see
+// http://www.gnu.org/licenses.
+// 
+// 
+// 
+// $LastChangedDate:$
+// $LastChangedRevision:$
+// $LastChangedBy:$ 
+//
+package org.txm.rcp.commands;
+
+import java.io.BufferedOutputStream;
+import java.io.File;
+import java.io.FileOutputStream;
+import java.io.OutputStreamWriter;
+import java.io.Writer;
+import java.util.Arrays;
+import java.util.Locale;
+
+import org.eclipse.core.commands.AbstractHandler;
+import org.eclipse.core.commands.ExecutionEvent;
+import org.eclipse.core.commands.ExecutionException;
+import org.eclipse.jface.dialogs.MessageDialog;
+import org.eclipse.osgi.util.NLS;
+import org.eclipse.swt.widgets.Shell;
+import org.eclipse.ui.handlers.HandlerUtil;
+import org.txm.Toolbox;
+import org.txm.core.messages.TXMCoreMessages;
+import org.txm.core.preferences.TBXPreferences;
+import org.txm.objects.Project;
+import org.txm.objects.Workspace;
+import org.txm.rcp.handlers.scripts.ExecuteImportScript;
+import org.txm.rcp.messages.TXMUIMessages;
+import org.txm.rcp.swt.dialog.TextDialog;
+import org.txm.searchengine.cqp.ReferencePattern;
+import org.txm.searchengine.cqp.corpus.CorpusManager;
+import org.txm.treetagger.core.preferences.TreeTaggerPreferences;
+import org.txm.utils.LangDetector;
+
+/**
+ * Import the text in the Clipboard as a corpus. The loader used is the QuickLoader.
+ * 
+ * The Clipboard is saved in the clipoard directory and then imported as TXT.
+ * 
+ * @author mdecorde
+ * 
+ */
+public class ImportClipboardText extends AbstractHandler {
+
+	/** The nextclipcorpus. */
+	static public int nextclipcorpus = 1;
+
+	/* (non-Javadoc)
+	 * @see org.eclipse.core.commands.AbstractHandler#execute(org.eclipse.core.commands.ExecutionEvent)
+	 */
+	@Override
+	public Object execute(ExecutionEvent event) throws ExecutionException {
+		String result = org.txm.rcp.utils.IOClipboard.read();
+		if (result == null || result.length() == 0) {
+			System.out.println("No copied text. Aborting.");
+			return null;
+		}
+		System.out.println(TXMUIMessages.importClipboardText);
+
+		try {
+			String corpusName = TXMUIMessages.clipboard_2.toUpperCase()+(nextclipcorpus++);
+			File wl = Toolbox.workspace.getLocation();
+			if (wl == null) {
+				System.err.println("Error: Toolbox is not correctly initialized. Clipboard import aborted.");
+				return null;
+			}
+			while (new File(wl, corpusName).exists()) {
+				corpusName = TXMUIMessages.clipboard_2.toUpperCase()+(nextclipcorpus++);
+			}
+			
+			String lang = TBXPreferences.getInstance().getString(TBXPreferences.CLIPBOARD_IMPORT_DEFAULT_LANG);
+			boolean askLang = TBXPreferences.getInstance().getBoolean(TBXPreferences.CLIPBOARD_IMPORT_ASK_LANG);
+			TextDialog dialog = new TextDialog(HandlerUtil.getActiveShell(event), "Select the import language to use", "What language must be used to import the clipboard content?", lang);
+			if (askLang) {
+				if (dialog.open() == TextDialog.CANCEL) return null;
+				lang = dialog.getText();
+			}
+			importText(result, corpusName, lang);
+			
+		} catch (Exception e) {
+			// TODO Auto-generated catch block
+			org.txm.utils.logger.Log.printStackTrace(e);
+		}
+		return null;
+	}
+
+	/**
+	 * Import text.
+	 *
+	 * @param text the text
+	 * @param corpusname the basename
+	 * @return the object
+	 * @throws Exception 
+	 */
+	public static Object importText(String text, String corpusname, String lang) throws Exception {
+		corpusname = corpusname.toUpperCase();
+		if (text.length() == 0) {
+			System.err.println(TXMUIMessages.clipboardIsEmpty);
+			return null;
+		}
+		String txmhome = Toolbox.getTxmHomePath();
+		new File(txmhome, "clipboard").mkdir(); //$NON-NLS-1$
+		File clipboardDirectory = new File(txmhome, "clipboard/" + corpusname); //$NON-NLS-1$
+		
+		if (CorpusManager.getCorpusManager().hasCorpus(clipboardDirectory.getName())) {
+			Shell shell = new Shell();
+			boolean b = MessageDialog.openConfirm(shell,
+					TXMUIMessages.confirm, NLS.bind(TXMUIMessages.theCorpusAndTheCorpusP0WillBeDeleted, clipboardDirectory.getName()));
+			if (!b) {
+				return null;
+			}
+		}
+		
+		org.txm.utils.DeleteDir.deleteDirectory(clipboardDirectory);
+		clipboardDirectory.mkdirs();
+		
+		File quicksrc = new File(clipboardDirectory, corpusname + ".txt"); //$NON-NLS-1$
+		try {
+			Writer writer = new OutputStreamWriter(new BufferedOutputStream(new FileOutputStream(quicksrc)), "UTF-8"); //$NON-NLS-1$ 
+			writer.write(text.replace("\t", "    ")); //$NON-NLS-1$ //$NON-NLS-2$
+			writer.close();
+		} catch (Exception e) {
+			org.txm.utils.logger.Log.printStackTrace(e);
+			return null;
+		}
+		
+		// configure project
+		Workspace w = Toolbox.workspace;
+		Project project = w.getProject(clipboardDirectory.getName());
+		if (project == null) {	
+			project = new Project(w, clipboardDirectory.getName());
+		}
+		project.setSourceDirectory(clipboardDirectory.getAbsolutePath());
+		project.setImportModuleName("txt"); //$NON-NLS-1$
+		project.setEncoding("UTF-8"); //$NON-NLS-1$
+		project.getEditionDefinition("default").setBuildEdition(true); //$NON-NLS-1$
+		project.getCommandPreferences("concordance").set("view_reference_pattern", 
+				ReferencePattern.referenceToString(Arrays.asList("lbn"), null));
+		
+		if (lang.length() == 0) lang = Locale.getDefault().getLanguage();
+		if ("??".equals(lang)) { //$NON-NLS-1$
+			LangDetector detector = new LangDetector(quicksrc);
+			lang = detector.getLang();
+			System.out.println(TXMCoreMessages.bind(TXMUIMessages.identifiedLanguage, lang));
+		}
+		project.setLang(lang); //$NON-NLS-1$
+		System.out.println(TXMCoreMessages.bind(TXMUIMessages.usingLanguage, project.getLang()));
+		
+		String ttpath = TreeTaggerPreferences.getInstance().getString(TreeTaggerPreferences.INSTALL_PATH);
+		
+		if (ttpath != null && ttpath.length() > 0 && new File(ttpath, "bin").isDirectory()) {
+			project.setAnnotate(true);
+		}
+		
+		ExecuteImportScript.executeScript(project); 
+		return null;
+	}
+}
\ No newline at end of file

Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/commands/workspace/UpdateCorpus.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/commands/workspace/UpdateCorpus.java	(revision 3440)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/commands/workspace/UpdateCorpus.java	(revision 3441)
@@ -9,16 +9,18 @@
 import org.eclipse.core.runtime.IProgressMonitor;
 import org.eclipse.core.runtime.IStatus;
 import org.eclipse.core.runtime.Status;
-import org.eclipse.jface.dialogs.MessageDialog;
 import org.eclipse.jface.viewers.ISelection;
 import org.eclipse.jface.viewers.IStructuredSelection;
+import org.eclipse.jface.window.Window;
 import org.eclipse.osgi.util.NLS;
 import org.eclipse.swt.widgets.Display;
 import org.eclipse.ui.handlers.HandlerUtil;
 import org.txm.core.preferences.TBXPreferences;
 import org.txm.objects.Project;
 import org.txm.rcp.commands.CloseEditorsUsing;
+import org.txm.rcp.commands.OpenImportForm;
 import org.txm.rcp.commands.RestartTXM;
+import org.txm.rcp.swt.dialog.UpdateCorpusDialog;
 import org.txm.rcp.utils.JobHandler;
 import org.txm.searchengine.cqp.corpus.MainCorpus;
 import org.txm.utils.logger.Log;
@@ -40,35 +42,42 @@
 		}
 		MainCorpus corpus = (MainCorpus) s;
 		
-		boolean updateEdition = false;
+		UpdateCorpusDialog dialog = new UpdateCorpusDialog(HandlerUtil.getActiveShell(event));
+		dialog.setDoUpdateEdition(TBXPreferences.getInstance().getBoolean(TBXPreferences.UPDATEEDITIONS));
+		dialog.setDoForceUpdate("true".equals(event.getParameter("org.txm.rcp.commands.workspace.UpdateCorpus.force")));
 		
-		// force corpus to be recomputed
-		String forceDirty = event.getParameter("org.txm.rcp.commands.workspace.UpdateCorpus.force"); //$NON-NLS-1$
-		if ("true".equals(forceDirty)) {
-			corpus.getProject().setDirty();
-			updateEdition = true;
+		if (dialog.open() != Window.OK) {
+			return null;
+		}
+		
+		if (dialog.getDoOpenCorpusParameters()) {
+			
+			corpus.getProject().setDoUpdate(true, dialog.getDoUpdateEdition());
+			if (dialog.getDoForceUpdate()) {
+				corpus.getProject().setDirty();
+			}
+			OpenImportForm.open(null, true);
 		} else {
-			if (corpus.getProject().getBuiltEditionNames().size() > 0) {
-				updateEdition = MessageDialog.openQuestion(HandlerUtil.getActiveShell(event), "Update editions", "Do you want to update the edition pages as well ?");
-			} else {
-				updateEdition = false; // no edition to do, skip the pager step when updating
-			}
+			
+			update(corpus, dialog.getDoForceUpdate(), dialog.getDoUpdateEdition());
 		}
 		
-		update(corpus, updateEdition);
-		
 		return corpus;
 	}
 	
 	public static JobHandler update(final MainCorpus corpus) {
-		return update(corpus, TBXPreferences.getInstance().getBoolean(TBXPreferences.UPDATEEDITIONS));
+		return update(corpus, false, TBXPreferences.getInstance().getBoolean(TBXPreferences.UPDATEEDITIONS));
 	}
 	
-	public static JobHandler update(final MainCorpus corpus, boolean updateEdition) {
+	public static JobHandler update(final MainCorpus corpus, boolean forceUpdate, boolean updateEdition) {
 		
 		final Project project = corpus.getProject();
 		if (project == null) return null;
 		
+		if (forceUpdate) {
+			project.setDirty();
+		}
+		
 		// String iname = project.getImportModuleName();
 		// if (!iname.matches("xtz|txt|hyperbase|discours|cnr|alceste|xml|xmltxm")) {
 		// System.out.println("Can't update a CQP corpus not imported with one of the XTZ, TXT, XML, XML-TXM, CNRS, Alceste, Hyperbase import modules.");
Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/views/corpora/CorporaView.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/views/corpora/CorporaView.java	(revision 3440)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/views/corpora/CorporaView.java	(revision 3441)
@@ -74,6 +74,7 @@
 import org.eclipse.ui.part.ViewPart;
 import org.txm.Toolbox;
 import org.txm.core.results.TXMResult;
+import org.txm.objects.CorpusBuild;
 import org.txm.objects.Project;
 import org.txm.objects.Workspace;
 import org.txm.rcp.CorporaSourceProvider;
Index: TXM/trunk/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Subcorpus.java
===================================================================
--- TXM/trunk/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Subcorpus.java	(revision 3440)
+++ TXM/trunk/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Subcorpus.java	(revision 3441)
@@ -139,6 +139,7 @@
 		
 		if (this.getParent() instanceof QueryBasedTXMResult) { // update the pQuery
 			this.pQuery = ((QueryBasedTXMResult)this.getParent()).getQuery();
+			this.setName(pQuery.getName());
 		}
 		
 		if (pID == null || pID.length() == 0) {
Index: TXM/trunk/org.txm.analec.rcp/src/org/txm/annotation/urs/URSCorpora.java
===================================================================
--- TXM/trunk/org.txm.analec.rcp/src/org/txm/annotation/urs/URSCorpora.java	(revision 3440)
+++ TXM/trunk/org.txm.analec.rcp/src/org/txm/annotation/urs/URSCorpora.java	(revision 3441)
@@ -26,7 +26,7 @@
 	private static final HashMap<CorpusBuild, Corpus> corpora = new HashMap<>();
 	
 	private static final HashMap<CorpusBuild, Vue> vues = new HashMap<>();
-	
+
 	/**
 	 * Create the ec file if needed, store a reference to the corpus if not already done.
 	 * 
@@ -250,21 +250,31 @@
 	
 	@Override
 	public boolean isAutomatic() {
+		
 		return false;
 	}
 	
 	@Override
 	public boolean processFile(File xmlFile, File binaryCorpusDirectory, HashMap<String, Object> parameters) {
+		
 		return false;
 	}
 	
 	@Override
 	public String getDetails() {
+		
 		return corpora.toString();
 	}
 	
 	@Override
 	public boolean hasAnnotationsToSave(CorpusBuild mcorpus) {
+
+		return hasAnnotationsToSaveStatic(mcorpus);
+	}
+	
+	public static boolean hasAnnotationsToSaveStatic(CorpusBuild mcorpus) {
+		
+		if (corpora.isEmpty()) return false;
 		if (!URSCorpora.hasCorpus(mcorpus)) return false; // no corpus instanced -> no annotations to save
 		return URSCorpora.getCorpus(mcorpus).isModifie();
 	}
@@ -275,6 +285,7 @@
 	 * @return true is an Analec corpus is already instanced
 	 */
 	private static boolean hasCorpus(CorpusBuild mcorpus) {
+		
 		return corpora.containsKey(mcorpus);
 	}
 }
Index: TXM/trunk/org.txm.analec.rcp/src/org/txm/annotation/urs/rcp/testers/IsURSCorpusDirty.java
===================================================================
--- TXM/trunk/org.txm.analec.rcp/src/org/txm/annotation/urs/rcp/testers/IsURSCorpusDirty.java	(revision 0)
+++ TXM/trunk/org.txm.analec.rcp/src/org/txm/annotation/urs/rcp/testers/IsURSCorpusDirty.java	(revision 3441)
@@ -0,0 +1,25 @@
+package org.txm.annotation.urs.rcp.testers;
+
+import java.util.List;
+
+import org.eclipse.core.expressions.PropertyTester;
+import org.txm.annotation.urs.URSCorpora;
+import org.txm.searchengine.cqp.corpus.MainCorpus;
+
+public class IsURSCorpusDirty extends PropertyTester {
+	
+	@Override
+	public boolean test(Object receiver, String property, Object[] args, Object expectedValue) {
+		
+		if (receiver instanceof List) {
+			List list = (List) receiver;
+			if (list.size() == 0) return true;
+			receiver = list.get(0);
+		}
+		if (receiver instanceof MainCorpus) {
+			return URSCorpora.hasAnnotationsToSaveStatic((MainCorpus)receiver);
+		}
+		
+		return false;
+	}
+}

Index: TXM/trunk/org.txm.conllu.rcp/src/org/txm/conllu/rcp/importsection/CoNLLUAnnotationSectionConfigurator.java
===================================================================
--- TXM/trunk/org.txm.conllu.rcp/src/org/txm/conllu/rcp/importsection/CoNLLUAnnotationSectionConfigurator.java	(revision 3440)
+++ TXM/trunk/org.txm.conllu.rcp/src/org/txm/conllu/rcp/importsection/CoNLLUAnnotationSectionConfigurator.java	(revision 3441)
@@ -9,6 +9,6 @@
 	@Override
 	public void installSections() {
 		
-		ImportModuleCustomization.additionalSections.put("conlluLoader.groovy", CoNLLUSection.class);
+		ImportModuleCustomization.addAdditionalSections("conllu", CoNLLUSection.class);
 	}
 }
Index: TXM/trunk/org.txm.cooccurrence.core/src/org/txm/cooccurrence/core/functions/Cooccurrence.java
===================================================================
--- TXM/trunk/org.txm.cooccurrence.core/src/org/txm/cooccurrence/core/functions/Cooccurrence.java	(revision 3440)
+++ TXM/trunk/org.txm.cooccurrence.core/src/org/txm/cooccurrence/core/functions/Cooccurrence.java	(revision 3441)
@@ -1612,9 +1612,13 @@
 	public boolean stepQueryLimits() {
 		// structural context
 
-		String fixedQuery = CQLQuery.fixQuery(pQuery.getQueryString(), this.getCorpus().getLang());
+		String fixedQuery = CQLQuery.fixQuery(pQuery.getQueryString(), this.getCorpus().getLang()); // a query starting with " or [ or (
 		if (fixedQuery.contains("@[") || fixedQuery.contains("@\"")) {
 			
+		} else if (fixedQuery.startsWith("(")) {
+			fixedQuery = "(@"+fixedQuery.substring(1);
+		} else if (fixedQuery.startsWith("((")) {
+			fixedQuery = "((@"+fixedQuery.substring(2);
 		} else {
 			fixedQuery = "@"+fixedQuery;
 		}
Index: TXM/trunk/org.txm.tigersearch.rcp/src/org/txm/tigersearch/imports/TIGERImportSectionConfigurator.java
===================================================================
--- TXM/trunk/org.txm.tigersearch.rcp/src/org/txm/tigersearch/imports/TIGERImportSectionConfigurator.java	(revision 3440)
+++ TXM/trunk/org.txm.tigersearch.rcp/src/org/txm/tigersearch/imports/TIGERImportSectionConfigurator.java	(revision 3441)
@@ -10,6 +10,6 @@
 	@Override
 	public void installSections() {
 		
-		ImportModuleCustomization.additionalSections.put("tigersearchLoader.groovy", TIGERSection.class);
+		ImportModuleCustomization.addAdditionalSections("tigersearch", TIGERSection.class);
 	}
 }
Index: TXM/trunk/org.txm.index.rcp/src/org/txm/index/rcp/handlers/SendIndexTo.java
===================================================================
--- TXM/trunk/org.txm.index.rcp/src/org/txm/index/rcp/handlers/SendIndexTo.java	(revision 3440)
+++ TXM/trunk/org.txm.index.rcp/src/org/txm/index/rcp/handlers/SendIndexTo.java	(revision 3441)
@@ -103,7 +103,7 @@
 					};
 					subcorpus.compute(false); // make it ready
 					subcorpus.setUserPersistable(false);
-					
+					subcorpus.setVisible(false);
 					//index.setUserPersistable(true); // make the index persistable to avoid bugs later
 				}
 			}
Index: TXM/trunk/org.txm.statsengine.r.rcp/src/org/txm/statsengine/r/rcp/handlers/SendToRCommand.java
===================================================================
--- TXM/trunk/org.txm.statsengine.r.rcp/src/org/txm/statsengine/r/rcp/handlers/SendToRCommand.java	(revision 3440)
+++ TXM/trunk/org.txm.statsengine.r.rcp/src/org/txm/statsengine/r/rcp/handlers/SendToRCommand.java	(revision 3441)
@@ -141,13 +141,14 @@
 	 * @param o the o
 	 * @throws Exception the exception
 	 */
-	public String send(TXMResult o) throws Exception {
+	public static String send(TXMResult o) throws Exception {
 		
 		RStatsEngine rengine = (RStatsEngine) StatsEnginesManager.getREngine();
 		HashMap<String, RTransformer<? extends TXMResult>> transformers = rengine.getTransformers();
 		if (transformers.containsKey(o.getClass().getName())) {
 			RTransformer<? extends TXMResult> transformer = rengine.getTransformers().get(o.getClass().getName());
-			return transformer.fromTXMtoR(o);
+			String s = transformer.fromTXMtoR(o);
+			return s;
 		}
 		else {
 			return null;
Index: TXM/trunk/org.txm.annotation.kr.rcp/src/org/txm/annotation/kr/rcp/commands/SaveAnnotations.java
===================================================================
--- TXM/trunk/org.txm.annotation.kr.rcp/src/org/txm/annotation/kr/rcp/commands/SaveAnnotations.java	(revision 3440)
+++ TXM/trunk/org.txm.annotation.kr.rcp/src/org/txm/annotation/kr/rcp/commands/SaveAnnotations.java	(revision 3441)
@@ -61,22 +61,6 @@
 			return null;
 		}
 		
-		// System.out.println("DISPLAY="+Display.getDefault());
-		final Boolean[] doit = new Boolean[1];
-		doit[0] = true;
-		Display.getDefault().syncExec(new Runnable() {
-			
-			@Override
-			public void run() {
-				if (!MessageDialog.openConfirm(Display.getDefault().getActiveShell(), "Before saving annotations...", "All editors using this corpus will be closed. Continue?")) {
-					doit[0] = false;
-				}
-			}
-		});
-		if (doit[0] == false) {
-			return null;
-		}
-		
 		JobHandler jobhandler = new JobHandler(NLS.bind("Saving annotations of {0}", corpus)) {
 			
 			@Override
@@ -108,7 +92,7 @@
 			}
 		};
 		
-		if (doit[0]) jobhandler.startJob(true);
+		jobhandler.startJob(true);
 		jobhandler.join();
 		return jobhandler;
 	}
Index: TXM/trunk/org.txm.annotation.kr.rcp/src/org/txm/annotation/kr/rcp/commands/SaveAnnotationsAndUpdateCorpus.java
===================================================================
--- TXM/trunk/org.txm.annotation.kr.rcp/src/org/txm/annotation/kr/rcp/commands/SaveAnnotationsAndUpdateCorpus.java	(revision 3440)
+++ TXM/trunk/org.txm.annotation.kr.rcp/src/org/txm/annotation/kr/rcp/commands/SaveAnnotationsAndUpdateCorpus.java	(revision 3441)
@@ -6,14 +6,18 @@
 import org.eclipse.core.runtime.IProgressMonitor;
 import org.eclipse.core.runtime.IStatus;
 import org.eclipse.core.runtime.Status;
+import org.eclipse.jface.dialogs.MessageDialog;
 import org.eclipse.jface.viewers.ISelection;
 import org.eclipse.jface.viewers.IStructuredSelection;
+import org.eclipse.jface.window.Window;
 import org.eclipse.osgi.util.NLS;
+import org.eclipse.swt.widgets.Display;
 import org.eclipse.ui.handlers.HandlerUtil;
 import org.txm.annotation.kr.core.KRAnnotationEngine;
 import org.txm.annotation.kr.core.preferences.KRAnnotationPreferences;
 import org.txm.rcp.commands.workspace.UpdateCorpus;
 import org.txm.rcp.messages.TXMUIMessages;
+import org.txm.rcp.swt.dialog.UpdateCorpusDialog;
 import org.txm.rcp.utils.JobHandler;
 import org.txm.rcp.views.corpora.CorporaView;
 import org.txm.searchengine.cqp.corpus.MainCorpus;
@@ -34,6 +38,10 @@
 		if (!(s instanceof MainCorpus)) {
 			return null;
 		}
+		
+		
+		
+		
 		MainCorpus corpus = (MainCorpus) s;
 		try {
 			
@@ -42,6 +50,27 @@
 				return null;
 			}
 			
+			// System.out.println("DISPLAY="+Display.getDefault());
+			final Boolean[] doit = new Boolean[1];
+			doit[0] = true;
+			Display.getDefault().syncExec(new Runnable() {
+				
+				@Override
+				public void run() {
+					UpdateCorpusDialog dialog = new UpdateCorpusDialog(Display.getDefault().getActiveShell());
+					dialog.setTitle("Before saving annotations...");
+					dialog.setMessages("Save Annotations and update the corpus.", dialog.getBottomMessage());
+					dialog.setDoForceUpdate(false);
+					dialog.setDoUpdateEdition(KRAnnotationPreferences.getInstance().getBoolean(KRAnnotationPreferences.UPDATE_EDITION));
+					
+					doit[0] = dialog.open() == Window.OK;
+				}
+			});
+			if (doit[0] == false) {
+				return null;
+			}
+			
+			
 			Log.info(NLS.bind("Saving {0} annotations...", corpus.getName()));
 			JobHandler job = SaveAnnotations.save(corpus);
 			if (job == null) {
@@ -59,7 +88,7 @@
 							
 							try {
 								monitor.setTaskName("Updating corpus");
-								if (corpus != null && UpdateCorpus.update(corpus, KRAnnotationPreferences.getInstance().getBoolean(KRAnnotationPreferences.UPDATE_EDITION)) != null) {
+								if (corpus != null && UpdateCorpus.update(corpus, false, KRAnnotationPreferences.getInstance().getBoolean(KRAnnotationPreferences.UPDATE_EDITION)) != null) {
 									monitor.worked(50);
 									this.syncExec(new Runnable() {
 										
Index: TXM/trunk/org.txm.groovy.core/src/groovy/org/txm/macro/r/PrintTableRSymbolAndSelectedLinesNamesMacro.groovy
===================================================================
--- TXM/trunk/org.txm.groovy.core/src/groovy/org/txm/macro/r/PrintTableRSymbolAndSelectedLinesNamesMacro.groovy	(revision 0)
+++ TXM/trunk/org.txm.groovy.core/src/groovy/org/txm/macro/r/PrintTableRSymbolAndSelectedLinesNamesMacro.groovy	(revision 3441)
@@ -0,0 +1,34 @@
+package org.txm.macro.r;
+// STANDARD DECLARATIONS
+
+import org.kohsuke.args4j.*
+
+import groovy.transform.Field
+
+import org.txm.Toolbox
+import org.txm.statsengine.r.core.RWorkspace
+import org.txm.statsengine.r.core.RResult
+import org.txm.core.results.TXMResult
+
+if (editor == null) {
+	println "No active editor. Aborting"
+	return
+}
+
+if (!(editor instanceof org.txm.lexicaltable.rcp.editors.LexicalTableEditor)) {
+	println "Active editor is not a table lexical editor ($editor). Aborting"
+	return
+}
+
+def table = editor.getResult()
+println "R name is: "+table.getRSymbol()
+
+monitor.syncExec(new Runnable() {
+	public void run() {
+		def selection = editor.getlineTableViewer().getSelection()
+		def names = table.getRowNames().asStringsArray()
+		println "Selection: "+selection.toList()
+		println "Names: "+names[selection.toList()]
+	}
+});
+
Index: TXM/trunk/org.txm.groovy.core/src/groovy/org/txm/macro/r/CreateLexicalTableFromRSymbolMacro.groovy
===================================================================
--- TXM/trunk/org.txm.groovy.core/src/groovy/org/txm/macro/r/CreateLexicalTableFromRSymbolMacro.groovy	(revision 0)
+++ TXM/trunk/org.txm.groovy.core/src/groovy/org/txm/macro/r/CreateLexicalTableFromRSymbolMacro.groovy	(revision 3441)
@@ -0,0 +1,45 @@
+package org.txm.macro.r;
+// STANDARD DECLARATIONS
+
+import org.kohsuke.args4j.*
+import groovy.transform.Field
+import org.txm.Toolbox
+import org.txm.statsengine.r.core.RWorkspace
+import org.txm.statsengine.r.core.RResult
+import org.txm.core.results.TXMResult
+import org.kohsuke.args4j.*
+import groovy.transform.Field
+import org.txm.rcp.swt.widget.parameters.*
+import org.txm.lexicaltable.core.statsengine.r.data.LexicalTableImpl
+import org.txm.lexicaltable.core.functions.LexicalTable
+import org.txm.searchengine.cqp.corpus.MainCorpus
+
+def selection = corpusViewSelection
+if (!(selection instanceof TXMResult)) {
+	println "Selection is not a result. Aborting"
+	return
+}
+
+@Field @Option(name="r_table_symbol", usage="R symbol of the R table to import", widget="String", required=false, def="")
+def r_table_symbol
+
+if (!ParametersDialog.open(this)) return
+
+if (!RWorkspace.getRWorkspaceInstance().containsVariable(r_table_symbol)) {
+	println "Error: no R object found for symbol '$r_table_symbol'"
+	return
+}
+def corpus = corpusViewSelection
+if (!(corpus instanceof MainCorpus)) {
+	corpus = corpus.getFirstParent(MainCorpus.class)
+}
+
+def lt = new LexicalTable(corpus);
+lt.setData(new LexicalTableImpl(r_table_symbol))
+lt.compute()
+
+monitor.syncExec(new Runnable() {
+	public void run() {
+		org.txm.rcp.views.corpora.CorporaView.reload()
+	}
+});
\ No newline at end of file
Index: TXM/trunk/org.txm.groovy.core/src/groovy/org/txm/macro/r/PrintRSymbolMacro.groovy
===================================================================
--- TXM/trunk/org.txm.groovy.core/src/groovy/org/txm/macro/r/PrintRSymbolMacro.groovy	(revision 0)
+++ TXM/trunk/org.txm.groovy.core/src/groovy/org/txm/macro/r/PrintRSymbolMacro.groovy	(revision 3441)
@@ -0,0 +1,39 @@
+package org.txm.macro.r;
+// STANDARD DECLARATIONS
+
+import org.kohsuke.args4j.*
+
+import groovy.transform.Field
+
+import org.txm.Toolbox
+import org.txm.statsengine.r.core.RWorkspace
+import org.txm.statsengine.r.core.RResult
+import org.txm.core.results.TXMResult
+
+if (editor != null) {
+	println "editor: $editor"
+}
+
+def selection = corpusViewSelection
+if (!(selection instanceof TXMResult)) {
+	println "Selection is not a result. Aborting"
+	return
+}
+def symbol = null;
+
+if (selection instanceof RResult) {
+	symbol = ((RResult)selection).getRSymbol();
+//} else if (selection.getStringParameterValue("rsymbol").length() > 0) {
+//	symbol = selection.getStringParameterValue("rsymbol")
+} else {
+	try {
+		symbol = selection.getClass().getDeclaredMethod("getSymbol").invoke(selection)
+	} catch(Exception e) {}
+}
+
+if (symbol != null) {
+	println "R Name of $selection is: $symbol"
+} else {
+	println "$selection has no R representation"
+}
+
Index: TXM/trunk/org.txm.edition.rcp/src/org/txm/edition/rcp/handlers/OpenEdition.java
===================================================================
--- TXM/trunk/org.txm.edition.rcp/src/org/txm/edition/rcp/handlers/OpenEdition.java	(revision 3440)
+++ TXM/trunk/org.txm.edition.rcp/src/org/txm/edition/rcp/handlers/OpenEdition.java	(revision 3441)
@@ -131,6 +131,16 @@
 	 * @param corpus the corpus
 	 * @return the object
 	 */
+	public static SynopticEditionEditor openEdition(CQPCorpus corpus) {
+		return openEdition(corpus, getDefaultEditions(corpus));
+	}
+	
+	/**
+	 * Open edition, but don't show a page
+	 *
+	 * @param corpus the corpus
+	 * @return the object
+	 */
 	public static SynopticEditionEditor openEdition(CQPCorpus corpus, String[] editions) {
 		return openEdition(corpus, Arrays.asList(editions));
 	}
Index: TXM/trunk/org.txm.lexicaltable.core/src/org/txm/lexicaltable/core/functions/LexicalTable.java
===================================================================
--- TXM/trunk/org.txm.lexicaltable.core/src/org/txm/lexicaltable/core/functions/LexicalTable.java	(revision 3440)
+++ TXM/trunk/org.txm.lexicaltable.core/src/org/txm/lexicaltable/core/functions/LexicalTable.java	(revision 3441)
@@ -562,9 +562,12 @@
 		else if (this.getPartition() != null) {
 			return NLS.bind(LexicalTableCoreMessages.info_creatingLexicalTableWithTheP0PartitionCommaPropertiesP1, this.getPartition().getName(), this.property.asString());
 		}
+		else if (this.parent instanceof Subcorpus) {
+			return NLS.bind(LexicalTableCoreMessages.info_creatingLexicalTableWithTheP0PartitionCommaPropertiesP1, this.getPartition().getName(), this.property.asString());
+		}
 		// from main corpus and subcorpus
 		else {
-			return NLS.bind(LexicalTableCoreMessages.info_creatingLexicalTableWithTheP0CorpusAndTheP1Subcorpus, this.getCorpus().getCorpusParent().getName(), this.getParent().getName());
+			return NLS.bind("Computing Lexical table on {0}", this.parent.getName());
 		}
 	}
 	
Index: TXM/trunk/org.txm.lexicaltable.core/src/org/txm/lexicaltable/core/statsengine/r/data/LexicalTableImpl.java
===================================================================
--- TXM/trunk/org.txm.lexicaltable.core/src/org/txm/lexicaltable/core/statsengine/r/data/LexicalTableImpl.java	(revision 3440)
+++ TXM/trunk/org.txm.lexicaltable.core/src/org/txm/lexicaltable/core/statsengine/r/data/LexicalTableImpl.java	(revision 3441)
@@ -124,6 +124,7 @@
 	 */
 	public LexicalTableImpl(String symbol) throws RWorkspaceException {
 		super(symbol);
+		initSortedIndex();
 	}
 	
 	/** The nolex. */
Index: TXM/trunk/org.txm.core/src/java/org/txm/Toolbox.java
===================================================================
--- TXM/trunk/org.txm.core/src/java/org/txm/Toolbox.java	(revision 3440)
+++ TXM/trunk/org.txm.core/src/java/org/txm/Toolbox.java	(revision 3441)
@@ -875,6 +875,7 @@
 				builder.append(" no CQP corpus with name: "+project.getName().toUpperCase());
 				builder.append("  the import was not done or failed");
 				builder.append("\n");
+				continue;
 			}
 			
 			List<?> errors = corpus.isBuildValid();
@@ -891,7 +892,6 @@
 				builder.append("\n");
 			}
 	
-			
 			if (Log.getLevel().intValue() < Level.INFO.intValue()) { // print more details if log level is lower than INFO
 				
 				builder.append("Project: "+project.getName()+" at "+project.getProjectDirectory());
@@ -920,6 +920,5 @@
 		}
 		
 		IOUtils.write(checkupResultFile, builder.toString());
-		
 	}
 }
